template <typename T,
	  typename NonRefT = typename std::decay<T>::type,
	  ENABLE_IF(monoid<NonRefT, op_plus,
			   wrapped_constructor<NonRefT()> >)>
NonRefT foo(T&& a, T&& b, T&& c) {
  // (a * b);
  NonRefT ret = std::forward<T>(a) +
    std::forward<T>(b) + std::forward<T>(c);
  return ret;
}

namespace foo_check {
  struct T {
    T() = default;
    T(const T&) = default;
    ~T() = default;
  };
  T operator+(const T&, const T&) {
    return T();
  }
  bool operator==(const T&, const T&) {
    return true;
  }
}

namespace catsfoot {
  template <>
  struct verified<monoid< ::foo_check::T, op_plus,
			  wrapped_constructor< ::foo_check::T()> > >
    : public std::true_type {
  };
}

namespace foo_check {
  void check(T a) {
    foo(a, a, a);
  }
}
