std::string getList(std::istream& input) {
  std::string ret = "";
  unsigned count = 0;
  char c;
  while (input >> c) {
    if ((c >= 'a') && (c <= 'e')) {
      ret.push_back(c);
      if (++count >= 5)
	return ret;
    }
  }
  return ret;
}

void axiom(std::istream& s) {
  std::string str = getList(s);
  axiom_assert(str.length() <= 5);
  for (auto c : str) {
    axiom_assert((c >= 'a') && (c <= 'e'));
  }
}

bool test_getList(std::mt19937& engine) {
  auto string_generator =
    term_generator_builder<std::string>{1024u}
  (engine,
   std::function<std::string()>
   ([&engine] () {
     char c;
     if (std::uniform_int_distribution<int>(0,2)(engine))
       c = std::uniform_int_distribution<char>('a', 'e')(engine);
     else
       c = std::uniform_int_distribution<char>()(engine);
     return std::string(1u, c);
   }),
   std::function<std::string(const std::string&,
			     const std::string&)>
   ([] (const std::string& a,
	const std::string& b) { return a + b; }));

  auto generator =
    term_generator_builder<std::string,
			   std::unique_ptr<std::istringstream>,
			   std::istream>{1024u}
      (engine,
       pick<std::string>(string_generator),
       std::function<std::unique_ptr<std::istringstream>(const std::string&)>
       ([] (const std::string& s) -> std::unique_ptr<std::istringstream>
       { return std::unique_ptr<std::istringstream>(new std::istringstream(s)); }),
       std::function<std::istream&(std::unique_ptr<std::istringstream>& i)>
       ([] (std::unique_ptr<std::istringstream>& i) -> std::istream&
       { return *i; }));

  std::istringstream in{std::string{}};
  if (!catch_errors(axiom, in))
    return false;

  if (!test(generator, axiom, "axiom"))
    return false;

  return true;
}
