// This file is a part of Catsfoot.
// Copyright (C) 2011  Uni Research
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef HAS_REQUIREMENTS_HH
# define HAS_REQUIREMENTS_HH

# include "../type_traits/try_first.hh"
# include "../type_traits/identity.hh"

namespace catsfoot {

  namespace details {
    template <typename T, typename = typename T::requirements>
    std::true_type has_requirements_helper(try_first, T&&) {
      static_assert(always_false<T>::value,
		    "Cannot use this function");
      return 0;
    }

    template <typename T>
    std::false_type has_requirements_helper(try_second, T&&) {
      static_assert(always_false<T>::value,
		    "Cannot use this function");
      return 0;
    }

    /// \brief Check whether T has a member type <tt>requirements</tt>.
    template <typename T>
    struct has_requirements:
      public identity<
      decltype(has_requirements_helper(try_first(),
				       std::declval<T>()))>::type
    {
    };

  }

}

#endif
