// This file is a part of Catsfoot.
// Copyright (C) 2011  Uni Research
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef IS_CONCEPT_HH
# define IS_CONCEPT_HH

# include <type_traits>

namespace catsfoot {

  /// \brief Base marker for concepts
  struct concept {};

  /// \brief Base marker for auto concepts
  struct auto_concept {};

  /// \brief Checks if T is an auto concept model
  /// \ingroup Predicates
  template <typename T>
  struct is_auto_concept:
    public std::is_base_of<auto_concept, T> {
  };

  /// \brief Checks if T is a concept model
  /// \ingroup Predicates
  template <typename T>
  struct is_concept:
    public std::is_base_of<concept, T> {
  };

}

#endif
