// This file is a part of Catsfoot.
// Copyright (C) 2011  Uni Research
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef STATIC_AND_HH
# define STATIC_AND_HH

namespace catsfoot {

  namespace details {

    template <typename... T>
    struct static_and;

    /// \brief Predicate true if all predicate parameters are true
    template <typename T, typename U, bool = T::value>
    struct static_binary_and: public std::false_type {
    };

    /// \brief Predicate true if all predicate parameters are true
    template <typename T, typename U>
    struct static_binary_and<T, U, true>: public U {
    };

    /// \brief Predicate true if all predicate parameters are true
    template <typename F, typename... T>
    struct static_and<F, T...>: public static_binary_and<F, static_and<T...> > {
    };

    /// \brief Predicate true if all predicate parameters are true
    template <>
    struct static_and<>: public std::true_type {
    };
  }

}

#endif
