// This file is a part of Catsfoot.
// Copyright (C) 2011  Uni Research
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef __TYPE_TO_STRING_HH
# define __TYPE_TO_STRING_HH

# include <catsfoot-config.hh>
# ifdef HAVE_CXXABI_H
#  include <cxxabi.h>
#  include <cstdlib>
# endif
# include <string>

namespace catsfoot {
  namespace details {

    /// \brief Gives a string of the type \a T
    ///
    /// \tparam T a type
    /// \returns A possibly demangled string representation of \a T
    template <typename T>
    std::string type_to_string() {
      std::string ret;
# ifdef HAVE_CXXABI_H
      int status;
      char* name = abi::__cxa_demangle(typeid(T).name(), 0, 0, &status);
      if (status != 0) {
# endif
	ret = typeid(T).name();
# ifdef HAVE_CXXABI_H
      }
      else {
	ret = name;
	free(name);
      }
#endif
      return ret;
    }

  }
}

#endif
