// This file is a part of Catsfoot.
// Copyright (C) 2011  Uni Research
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

template <typename T,
	  typename NonRefT = typename std::decay<T>::type,
	  ENABLE_IF(monoid<NonRefT, op_plus,
			   wrapped_constructor<NonRefT()> >)>
NonRefT foo(T&& a, T&& b, T&& c) {
  // (a * b);
  NonRefT ret = std::forward<T>(a) +
    std::forward<T>(b) + std::forward<T>(c);
  return ret;
}

namespace foo_check {
  struct T {
    T() = default;
    T(const T&) = default;
    ~T() = default;
  };
  T operator+(const T&, const T&) {
    return T();
  }
  bool operator==(const T&, const T&) {
    return true;
  }
}

namespace catsfoot {
  template <>
  struct verified<monoid< ::foo_check::T, op_plus,
			  wrapped_constructor< ::foo_check::T()> > >:
    public std::true_type {
  };
}

namespace foo_check {
  void check(T a) {
    foo(a, a, a);
  }
}
