#include <wrappers/function_wrappers.hh>
#include <cassert>

struct A {
  int i;
  A(int i): i(i) {}
  A(const A&) = default;
};

int function(A& a, const A& b) {
  a.i += b.i;
  return a.i;
}

int main() {
  A a = 42;
  A b = 51;
  int res = catsfoot::remove_side_effect(catsfoot::wrap(function))(a, b);
  assert(res == (42 + 51));
  assert(a.i == 42);
  assert(b.i == 51);

  return 0;
}
