// This file is a part of Catsfoot.
// Copyright (C) 2011  Uni Research
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <dataset/pick.hh>
#include <dataset/random_term_generator.hh>
#include <wrappers/operators.hh>
#include <random>
#include <iostream>

int main() {
  auto int_gen =
    catsfoot::list_data_generator<int>
    ({-1, 0, 1, 2, 3});

  std::mt19937 engine;
  auto term_generator =
    catsfoot::term_generator_builder<int>{}
  (engine,
   catsfoot::pick<int>(int_gen),
   std::function<int(int, int)>(catsfoot::op_plus()));

  bool got_pick = false;
  bool got_term = false;
  bool got_positive = false;
  auto s = term_generator.get(catsfoot::selector<int>());
  for (auto i = s.begin(); i != s.end(); ++i) {
    std::cout << *i << std::endl;
    if (*i >= 0)
      got_positive = true;

    if ((*i < -1) || (*i > 3))
      got_term = true;
    else
      got_pick = true;
  }

  return (got_term && got_pick && got_positive)?0:1;
}
