// This file is a part of Catsfoot.
// Copyright (C) 2011  Valentin David
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <wrappers/members.hh>
#include <cassert>

struct A {
  int foo(int i) {
    return 42 + i;
  }

  int foo(int i) const {
    return 22 + i;
  }
};

struct B {
  static int foo(int i) {
    return 51 + i;
  }
};

int foo(int i) {
  return 61 + i;
}

DEF_MEMBER_WRAPPER(foo)
DEF_STATIC_MEMBER_WRAPPER(foo)
DEF_FUNCTION_WRAPPER(foo)

int main()
{
  A a;
  assert(member_foo{}(a, 10) == 52);
  assert(member_foo{}(const_cast<const A&>(a), 10) == 32);
  assert(static_member_foo<B>{}(10) == 61);
  assert(function_foo{}(10) == 71);

  return 0;
}
